/*	
 *	supp.c
 *
 *	VvCuT|[g[`W
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Sat Sep  7 18:26:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 *	* Sun Dec  1 19:12:00 JST 2002 Naoyuki Sawa
 *	- bgdisp()ǉ܂B
 *	* Sun Dec  1 21:22:00 JST 2002 Naoyuki Sawa
 *	- symbolf()ǉ܂B
 *	* Sun Dec  2 07:11:00 JST 2002 Naoyuki Sawa
 *	- fxput()/fxputstr()/fxprintf()ǉ܂B
 *	  ǋL:->grfont()/grputstr()/grprintf()ɖ̕ύXB
 *	* Sun Dec  2 19:00:00 JST 2002 Naoyuki Sawa
 *	- XvCgn֐̃vtBNXsp*Ach*ɓB
 *	  afn֐̃vtBNXbg*ɓB
 *	  OtBbNn֐̃vtBNXgr*ɓB
 *	* Tue Dec  3 05:54:00 JST 2002 Naoyuki Sawa
 *	- die()ǉB
 *	* Wed Dec  4 05:52:00 JST 2002 Naoyuki Sawa
 *	- bgcls()/bgput()ǉB
 *	* Fri Dec 27 12:15:00 JST 2002 Naoyuki Sawa
 *	- grfont()tHg𕪗Afntadr()ǉB
 *	- pausedisp()ǉB
 *	* Wed Jan  1 11:02:00 JST 2003 Naoyuki Sawa
 *	- grfont()ɔwiFwǉB
 *	  grputstr()/grprintf()̐FwdlƂȂ܂B
 */
#include "supp.h"

/****************************************************************************
 *	die
 ****************************************************************************/

/* CLiPdie()Ɠ@\֐́AVvCuł̎łB */
void
die(const char* fmt, ...)
{
extern void simple_error(char* fmt, ...); /* VvCu̔JAPI */

	va_list ap;

	va_start(ap, fmt);
	vsprintf(_def_vbuff, fmt, ap); /* VXepzʂ𗘗p!! */
	va_end(ap);

	simple_error(_def_vbuff);
	thread_return();
}

/****************************************************************************
 *	fntadr
 ****************************************************************************/

/* tHgf[^AhX擾܂B
 * [in]
 *	code		R[h(0`255Abit31-8͖܂)
 * [out]
 *	߂l		tHgf[^AhX
 * [note]
 *	* tHgf[^́A1C1oCgŁA1`8C̏ɕł܂B
 */
const unsigned char*
fntadr(int code)
{
extern unsigned char FONT[];
	static unsigned char* font; /* rs`shbłI */

	PBMP_FILEHEADER* header;
	unsigned char tmp[128]; /* 傫̂ŁAX^bNɎ̂͊댯H */
	unsigned char* dst;
	unsigned char a, b;
	int row, col, line, bit;

	/* ̂݁AtHgf[^܂B */
	if(font == NULL) {
		/* tHgOtBbNf[^擾B */
		header = (PBMP_FILEHEADER*)FONT;
		if((strncmp((char*)&header->head, "PMBP", 4) != 0) ||	/* VOl` */
		   (header->bpp != 1 || header->mask != 0) ||		/* 1bit}XNȂH */
		   (header->w != 128 || header->h != 128)) DIE();	/* 128x128H */
		font = (unsigned char*)(header + 1);
		/* OtBbNf[^(CP)LN^f[^(P)ɕёւB */
		dst = font;
		for(row = 0; row < 16; row++) {				/* 16s[v */
			memcpy(tmp, dst, 128);				/* ݍs̃OtBbNf[^ꎞobt@ɃRs[ */
			for(col = 0; col < 16; col++) {			/* 16[v */
				for(line = 0; line < 8; line++) {	/* 8C[v */
					a = tmp[line * 16 + col];	/* ݕ̃Cf[^擾 */
					b = 0;
					for(bit = 0; bit < 8; bit++) {
						b <<= 1;		/* Erbg](Drawn->XvCgnϊ) */
						b |= a & 1;
						a >>= 1;
					}
					*dst++ = b;			/* ݕ̃Cf[^i[ */
				}
			}
		}
	}

	/* ̃tHgAhX擾B(tHgf[^́APʕтŁAꕶ8oCgł) */
	return font + (code & 0xff) * 8;
}

/****************************************************************************
 *	spcls
 ****************************************************************************/

void
spcls(int obj)
{
	while(obj < N_OBJS) sppos(obj++, -8, -8);
}

/****************************************************************************
 *	chdisp
 ****************************************************************************/

/* ̃XvCg\AL\܂B
 * [in]
 *	obj		ŏ̃XvCgv[ԍ
 *	x, y		L̒SW
 *	chr		L\̂ւ̃|C^
 * [out]
 *	߂l		Ō̃XvCgv[ԍ{P
 * [note]
 *	* spdisp()ւ̈64zXvCgv[ԍw肵ꍇA
 *	  spdisp()ɏԂdlɈˑĂ܂B
 *	  chdisp()֐g̓XvCgv[ԍ͈̔͂lĂ܂B
 */
int
chdisp(int obj, int x, int y, const CHR* chr)
{
	int col, row, pno;

	/* SWւ̃ItZbgA_W炵܂B */
	x -= chr->x;
	y -= chr->y;

	/* L\AeXvCg\܂B */
	for(row = 0; row < chr->h; row++) {
		for(col = 0; col < chr->w; col++) {
			pno = chr->pno + 0x10 * row + col;
			spdisp(obj++, x + col * 8, y + row * 8, pno);
		}
	}

	return obj;
}

/****************************************************************************
 *	sphit
 ****************************************************************************/

/* XvCgm̃sNZPʂ̓蔻s܂B
 * [in]
 *	(x1,y1),pno1	XvCg1̍Wƃp^[ԍ
 *	(x2,y2),pno2	XvCg2̍Wƃp^[ԍ
 * [out]
 *	߂l		Ȃ1AOȂ0Ԃ܂B
 * [note]
 *	* 蔻́AXvCgp^[̃}XNgčs܂B
 *	  ̃XvCgp^[̃}XN1sNZłdȂĂ΁A
 *	  ƌȂ܂B
 */
int
sphit(int x1, int y1, int pno1, int x2, int y2, int pno2)
{
	extern unsigned char PAT[];

	int i;
	unsigned char *p1, *p2;
	unsigned short mask1, mask2;

	/* ܂ȔB */
	if(x1 + 8 - 1 < x2) return 0; /* XvCg1XvCg2荶 */
	if(y1 + 8 - 1 < y2) return 0; /* XvCg1XvCg2 */
	if(x2 + 8 - 1 < x1) return 0; /* XvCg1XvCg2E */
	if(y2 + 8 - 1 < y1) return 0; /* XvCg1XvCg2艺 */

	/* XvCgp^[AhXvZB */
	p1 = &PAT[(pno1 & 0xff/*Ô*/) * 8 * 3/*bit1,bit0,mask*/];
	p2 = &PAT[(pno2 & 0xff/*Ô*/) * 8 * 3/*bit1,bit0,mask*/];

	/* eCł̃sNZPʂ̓蔻B */
	if(y1 <= y2) {
		i = y2 - y1;
		p1 += i * 3;
	} else {
		i = y1 - y2;
		p2 += i * 3;
	}
	if(x1 <= x2) {
		x2 -= x1;
		      x1 = 0;
	} else {
		x1 -= x2;
		      x2 = 0;
	}
	do {
		/* ӁFXvCgf[^0:s/1: */
		mask1 = (p1[2/*mask*/] ^ 0xff) << x1;
		mask2 = (p2[2/*mask*/] ^ 0xff) << x2;
		if(mask1 & mask2) return 1;
		p1 += 3;
		p2 += 3;
	} while(++i < 8);

	return 0;
}

/****************************************************************************
 *	chhit
 ****************************************************************************/

/* Lm̃sNZPʂ̓蔻s܂B
 * [in]
 *	(x1,y1),chr1	L1̍Wƃp^[ԍ
 *	(x2,y2),chr1	L2̍Wƃp^[ԍ
 * [out]
 *	߂l		Ȃ1AOȂ0Ԃ܂B
 * [note]
 *	* sphit()[note]QƂĂB
 */
int
chhit(int x1, int y1, const CHR* chr1, int x2, int y2, const CHR* chr2)
{
	int col1, row1, pno1, col2, row2, pno2;

	/* SWւ̃ItZbgA_W炵܂B */
	x1 -= chr1->x;
	y1 -= chr1->y;
	x2 -= chr2->x;
	y2 -= chr2->y;

	/* ܂ȔB */
	if(x1 + chr1->w * 8 - 1 < x2) return 0; /* L1L2荶 */
	if(y1 + chr1->h * 8 - 1 < y2) return 0; /* L1L2 */
	if(x2 + chr2->w * 8 - 1 < x1) return 0; /* L1L2E */
	if(y2 + chr2->h * 8 - 1 < y1) return 0; /* L1L2艺 */

	/* L1ƃL2̑SXvCg̑蔻B */
	for(row1 = 0; row1 < chr1->h; row1++) {
		for(col1 = 0; col1 < chr1->w; col1++) {
			pno1 = chr1->pno + 0x10 * row1 + col1;
			for(row2 = 0; row2 < chr2->h; row2++) {
				for(col2 = 0; col2 < chr2->w; col2++) {
					pno2 = chr2->pno + 0x10 * row2 + col2;
					if(sphit(x1 + col1 * 8, y1 + row1 * 8, pno1,
						 x2 + col2 * 8, y2 + row2 * 8, pno2)) return 1;
				}
			}
		}
	}

	return 0;
}

/****************************************************************************
 *	bgcls
 ****************************************************************************/

/* BGLN^0ŃNA܂B
 * [note]
 *	* VvCucls()ĝł́A16x11͈̔͂NAł܂B
 *	  cls()AȈՃR\[pclSpriteBGClear()𗘗pĂ邩łB
 *	  ŁA32x32͈̔͑SĂNA֐pӂ܂B
 */
void
bgcls()
{
	memset(pclSpriteBGGetAdr(0), 0, sizeof(short) * BG_CX * BG_CY);
}

/****************************************************************************
 *	bgput
 ****************************************************************************/

/* BG1LN^u܂B
 * [in]
 *	x, y		]̍ʒu(0`31)
 *	ch		LN^R[hB
 * [note]
 *	* VvCulocate()printstr()/siprintf()ĝł́A
 *	  16x11͈̔͊OɃLN^u܂B(sNZXN[ɑΉłȂ)
 *	  ܂A(15,10)̈ʒuɃLN^uƁALN^XN[Ă܂܂B
 *	  printstr()AȈՃR\[֐pclSpriteBGPutCharacter()𗘗pĂ邩łB
 *	  ŁApclSpriteBGSetCharacter()̊֐pӂ܂B
 */
void
bgput(int x, int y, int code)
{
	pclSpriteBGSetCharacter(0, x & 31, y & 31, code);
}

/****************************************************************************
 *	bgdisp
 ****************************************************************************/

/* ̃XvCg\LABGɕ\܂B
 * [in]
 *	x, y		]̍ʒu(0`31)
 *	chr		L\̂ւ̃|C^
 * [note]
 *	* L\̂̒SItZbg(x,y)͎QƂ܂B
 */
void
bgdisp(int x, int y, const CHR* chr)
{
	int col, row, pno;

	/* L\AeXvCg\܂B */
	for(row = 0; row < chr->h; row++) {
		for(col = 0; col < chr->w; col++) {
			pno = chr->pno + 0x10 * row + col;
			pclSpriteBGSetCharacter(0, (x + col) & 31, (y + row) & 31, pno);
		}
	}

}

/****************************************************************************
 *	bgscrl
 ****************************************************************************/

/* BGʂ̃XN[ʒuݒ肵܂B
 * [in]
 *	x, y		XN[ʒu
 * [note]
 *	* VvCuɂ́AOtBbNʂ̃XN[ʒuݒ肷
 *	  home()֐͂̂łABGʂ̃XN[ʒuݒ肷֐
 *	  Ȃ̂ŁAOŗpӂ܂B
 */
void
bgscrl(int x, int y)
{
	pclSpriteBGSetPosition(0, x, y);
}

/****************************************************************************
 *	grcls
 ****************************************************************************/

void
grcls(int color)
{
	unsigned char mask, bit1, bit0;
	unsigned char* p;
	int y;

	switch(color) {
	case  0: bit1 = 0x00; bit0 = 0x00; mask = 0x00; break;
	case  1: bit1 = 0x00; bit0 = 0xff; mask = 0x00; break;
	case  2: bit1 = 0xff; bit0 = 0x00; mask = 0x00; break;
	case  3: bit1 = 0xff; bit0 = 0xff; mask = 0x00; break;
	default: bit1 = 0x00; bit0 = 0x00; mask = 0xff; break;
	}
	p = pclSpriteBGGetFrameAdr(1);
	for(y = 0; y < 256; y++) {
		memset(p, bit1, 256 / 8); p += 256 / 8;
		memset(p, bit0, 256 / 8); p += 256 / 8;
		memset(p, mask, 256 / 8); p += 256 / 8;
	}
}

/****************************************************************************
 *	paint
 ****************************************************************************/

/* * Sat Jul 20 08:18:00 JST 2002 Naoyuki Sawa
 * - L^CX^v̎_łrender_paint()x[XɁAVvCupɈڐA܂B
 *   ڐAɍۂăRg͏CĂ܂̂ŁAꕔAAPIgpz肵RgcĂ܂B
 * - hԂFێϐucv̌^ɒӁI
 *   APIprender_paint()łunsigned charłAVvCułintłB
 *   point()͓lƂ-1Ԃ̂ŁAintŕێĂȂƓ̓hԂł܂B
 */

/* SĂ܂BxłB
 * Q[ł́AhԂvʂ͏ȂƎv̂ŁA
 * ̂܂܂łɖ͂ȂƎv܂B
 */
void
paint(int x0, int y0, int color)
{
/* hԂ_X^bNTCYF
 * ƂAȂ蕡GȓhԂł24xłA
 * Ô߁A]TŁA傫߂ɎĂƂɂ܂B
 * ܂傫ƁAP/ECEł̓X^bNӂ̂ŁAӂB
 */
#define RENDER_PAINT_STACK_SIZE	64

/* r[|[gTCYF
 * ʂɌĂ镔(DISP_X~DISP_Y)ł͂ȂA
 * OtBbNʑŜ̃TCY(256~256)Ƃ܂B
 */
#define VP_LEFT		  0
#define VP_RIGHT	256
#define VP_TOP		  0
#define VP_BOTTOM	256

	short stack[RENDER_PAINT_STACK_SIZE][2]; /* ߖ̂short */
	int i_stack, x, y, x1, x2;
	int c; /* APIłunsigned charłAVvCułintłĨRgQ */

	/* hԂJn_r[|[gOȂA܂B */
	if(x0 < VP_LEFT || VP_RIGHT  - 1 < x0) return;
	if(y0 < VP_TOP  || VP_BOTTOM - 1 < y0) return;

	/* hԂF擾܂B */
	c = point(x0, y0);

	/* hԂJn_ɓhԂFȂA܂B */
	/* if(c == color) return; */
	/* ->悭lÃ`FbN͕svłB
	 *   hԂJn_ɓhԂFȂA
	 *   1. X^bNɍŏ(x0,y0)ςށB
	 *   2. while()[v̒(x0,y0)oB
	 *   3. ɓhĂ̂ŁAcontinueŔ΂B
	 *   4. X^bN͋Ȃ̂ŁAIB
	 *   ƂȂAɏI܂B
	 */

	/* hԂJn_X^bNɐς݂܂B */
	stack[0][0] = x0;
	stack[0][1] = y0;
	i_stack = 1;

	/* hԂ_ȂȂ܂... */
	while(i_stack != 0) {
		/* hԂ_o܂B */
		i_stack--;
		x0 = stack[i_stack][0];
		y0 = stack[i_stack][1];

		/* ɓhĂA΂܂B */
		if(point(x0, y0) == color) continue;

		/* hF̍[T܂B */
		x1 = x0;
		for(;;) {
			x1--;
			if(x1 < VP_LEFT) break; /* r[|[gO */
			if(point(x1, y0) != c) break; /* ʐF */
		}
		x1++; /* s߂Ă̂Ŗ߂ */

		/* hF̉E[T܂B */
		x2 = x0;
		for(;;) {
			x2++;
			if(x2 > VP_RIGHT - 1) break; /* r[|[gO */
			if(point(x2, y0) != c) break; /* ʐF */
		}
		x2--; /* s߂Ă̂Ŗ߂ */

		/* E̊ԂhԂ܂B */
		for(x = x1; x <= x2; x++) {
			pset(x, y0, color);
			/* pceLCDTrans()ĂԂƁAhԂ̗lq1sNZPʂŊώ@ł܂B */
			/* pceLCDTrans() */
		}
		/* pceLCDTrans()ĂԂƁAhԂ̗lq1CPʂŊώ@ł܂B */
		/* pceLCDTrans() */

		/* ̃C̒B */
		if(y0 != VP_TOP) {
			y = y0 - 1;
			x = x1;
			for(;;) {
				/* hF̎n܂T܂B */
				for(;;) {
					if(x > x2) break;
					if(point(x, y) == c) break;
					x++;
				}
				if(x > x2) break; /* Ȃ */

				/* hF̏IT܂B */
				for(;;) {
					if(x > x2) break;
					if(point(x, y) != c) break;
					x++;
				}

				/* hF̏ÏʒuX^bNɐς݂܂B */
				if(i_stack < RENDER_PAINT_STACK_SIZE) {
					stack[i_stack][0] = x - 1; /* s߂Ă̂Ŗ߂ */
					stack[i_stack][1] = y;
					i_stack++;
				}
			}
		}

		/* ̃C̒B */
		if(y0 != VP_BOTTOM - 1) {
			y = y0 + 1;
			x = x1;
			for(;;) {
				/* hF̎n܂T܂B */
				for(;;) {
					if(x > x2) break;
					if(point(x, y) == c) break;
					x++;
				}
				if(x > x2) break; /* Ȃ */

				/* hF̏IT܂B */
				for(;;) {
					if(x > x2) break;
					if(point(x, y) != c) break;
					x++;
				}

				/* hF̏ÏʒuX^bNɐς݂܂B */
				if(i_stack < RENDER_PAINT_STACK_SIZE) {
					stack[i_stack][0] = x - 1; /* s߂Ă̂Ŗ߂ */
					stack[i_stack][1] = y;
					i_stack++;
				}
			}
		}
	}

#undef RENDER_PAINT_STACK_SIZE
#undef VP_LEFT
#undef VP_RIGHT
#undef VP_TOP
#undef VP_BOTTOM
}

/****************************************************************************
 *	symbolf
 ****************************************************************************/

/* OtBbNʂɏt`悵܂B
 * [in]
 *	x, y		̍W(sNZPʁA0`255)
 *	type		\tHg(0`2)
 *	color		F(-1`3)
 *	fmt		
 *	...		p[^
 * [note]
 *	* ̊֐́AWĴ߂ɁAVXepzʗ̈𗘗p܂B
 */
void
symbolf(int x, int y, int type, int color, char* fmt, ...)
{
	va_list ap;

	/* tWJ܂B */
	va_start(ap, fmt);
	vsprintf(_def_vbuff, fmt, ap); /* VXepzʂ𗘗p!! */
	va_end(ap);

	/* WJ`悵܂B */
	symbol(x, y, _def_vbuff, type, color);
}

/****************************************************************************
 *	grfont
 ****************************************************************************/

/* OtBbNʂ8~8sNZtHg`܂B
 * [in]
 *	x, y		̍W(LN^PʁA0`31)
 *	code		R[h(0`255)
 *	color		bit3`0: OiF(0:/1:/2:/3:/4`15:)
 *			bit7`4: wiF(0:/1:/2:/3:/4`15:)
 * [note]
 *	* OiFEwiFɓw肵ĂÃsNZc킯ł͂܂B
 *	  Fŕ`悳邾Ȃ̂ŁAɂ̃sNZ͏㏑܂B
 */
void
grfont(int x, int y, int code, int color)
{
	const unsigned char* src;
	unsigned char *dst, mask, t1, t0, tm, b1, b0, bm;
	int line;

	/* ]tHgAhXE]t[obt@AhX擾܂B */
	src = fntadr(code);
	dst = pclSpriteBGGetFrameAdr(1)
	    + (256/*[pixel]*/ / 8/*[bit]*/ * 3/*[plane]*/ * 8/*[line]*/) * (y & 31) + (x & 31);

	/* OiFEwiFݒ肵܂B */
	switch(color & 0x0f) {
	case 0x00: t1 = 0x00; t0 = 0x00; tm = 0x00; break;
	case 0x01: t1 = 0x00; t0 = 0xff; tm = 0x00; break;
	case 0x02: t1 = 0xff; t0 = 0x00; tm = 0x00; break;
	case 0x03: t1 = 0xff; t0 = 0xff; tm = 0x00; break;
	default  : t1 = 0x00; t0 = 0x00; tm = 0xff; break;
	}
	switch(color & 0xf0) {
	case 0x00: b1 = 0x00; b0 = 0x00; bm = 0x00; break;
	case 0x10: b1 = 0x00; b0 = 0xff; bm = 0x00; break;
	case 0x20: b1 = 0xff; b0 = 0x00; bm = 0x00; break;
	case 0x30: b1 = 0xff; b0 = 0xff; bm = 0x00; break;
	default  : b1 = 0x00; b0 = 0x00; bm = 0xff; break;
	}

	for(line = 0; line < 8; line++) {
		mask = *src++; /* fntadr()ł̃tHgf[^ɁAPʂɕёւς */
		dst[256/*[pixe]*/ / 8/*[bit]*/ * 0] = (t1 & mask) | (b1 & ~mask); /* bit1 */ 
		dst[256/*[pixe]*/ / 8/*[bit]*/ * 1] = (t0 & mask) | (b0 & ~mask); /* bit0 */ 
		dst[256/*[pixe]*/ / 8/*[bit]*/ * 2] = (tm & mask) | (bm & ~mask); /* mask */ 
		dst += 256/*[pixe]*/ / 8/*[bit]*/ * 3/*[plane]*/;
	}
}

/****************************************************************************
 *	grputstr
 ****************************************************************************/

/* OtBbNʂ8~8sNZtHgŕ`܂B
 * [in]
 *	x, y		̍W(LN^PʁA0`31)
 *	str		
 *	color		bit3`0: OiF(0:/1:/2:/3:/4`15:)
 *			bit7`4: wiF(0:/1:/2:/3:/4`15:)
 * [note]
 *	* 񒆂SO(\x0e)uƁASI(\x0f)܂ł̊ԁA
 *	  񒆂̔pJ^Ji𔼊pЂ炪ȂƂĕ\܂B
 *	  Ⴆ΁A
 *		str = ""
 *	  ́A
 *		ACEGITVXZ\
 *	  ƕ\܂B
 *	* GۃGfB^ȂASÓuCtrl+PCtrl+Nvœ͂ł܂B
 *	  ܂ASÍuCtrl+PCtrl+Ovœ͂ł܂B
 *	* VtgAEgԂ́Asł͉܂B
 *	  ֐ԂƃVtgAEgԂ͉A͕KVtgCԂn܂܂B
 *	* SO/SỈ߂͓ƎłASOœꃂ[hESIŒʏ탂[hƂ͖̂{̈ӖƓłB
 *	  ȂƂȂAuVtgCœꃂ[h**vuVtgAEgœꃂ[h**v
 *	  ƎvĂ܂ACƃAEg̈Ӗ͋t悤łB
 *	  uVtgAEgœꃂ[h**vuVtgCœꃂ[h**v悤łB
 *	  SIR[h14ASOR[h15Ȃ̂ŁAԂ猾ĂԂ񂻂Ȃ̂ł傤B
 *	  ڂ͖mFȂ̂ŁAvmFłBƎ߂AǂłȂ̂ł(^^;
 */
void
grputstr(int x, int y, const char* str, int color)
{
	int x0, so, c;

	x0 = x; /* sɂ֖̌߂܂ */
	so = 0; /* 0:J^Ji/1:Ђ炪 */

	while((c = *str++) != '\0') {
		/* R[h̏B(\܂) */
		switch(c) {
		case '\n': /* LF(s) */
			x = x0;
			y++;
			continue;
		case '\x0e': /* SO(VtgAEg) */
			so = 1;
			continue;
		case '\x0f': /* SI(VtgC) */
			so = 0;
			continue;
		}

		/* J^JiЂ炪ȕϊB(font.bmpQ) */
		if(so) {
			if('' <= c && c <= '') {
				c -= 0x20;
			} else if('' <= c && c <= '') {
				c += 0x20;
			}
		}

		/* ꕶ\B */
		grfont(x, y, c, color);
		x++;
	}
}

/****************************************************************************
 *	grrintf
 ****************************************************************************/

/* OtBbNʂ8~8sNZtHgŏt`܂B
 * [in]
 *	x, y		̍W(LN^PʁA0`31)
 *	color		bit3`0: OiF(0:/1:/2:/3:/4`15:)
 *			bit7`4: wiF(0:/1:/2:/3:/4`15:)
 *	fmt		
 *	...		p[^
 * [note]
 *	* ̊֐́AWĴ߂ɁAVXepzʗ̈𗘗p܂B
 */
void
grprintf(int x, int y, int color, const char* fmt, ...)
{
	va_list ap;

	/* tWJ܂B */
	va_start(ap, fmt);
	vsprintf(_def_vbuff, fmt, ap); /* VXepzʂ𗘗p!! */
	va_end(ap);

	/* WJ`悵܂B */
	grputstr(x, y, _def_vbuff, color);
}

/****************************************************************************
 *	pausedisp
 ****************************************************************************/

static void (*old_LCDTransDirect)(const unsigned char* lcd);

/* ʓ]̒OtbNāAuPAUSEvd˕`܂B
 * VvCu͖Sʓ]ŝŁAd˕`̑ޔE͕svłB
 */
static void
new_LCDTransDirect(const unsigned char* lcd)
{
	static const char msg[] = "PAUSE";
	const unsigned char* src;
	unsigned char* dst;
	int i, j;

	/* ʂ̂قڒɁuPAUSEv\B */
	for(i = 0; i < 5; i++) {
		src = fntadr(msg[i]);
		dst = (unsigned char*)lcd + (2 * 88) * (5 + i) + (2 * 40);
		for(j = 0; j < 8; j++) {
			*dst++ = *src; /* bit1 */
			*dst++ = *src; /* bit0 */
			src++;
		}
	}

	/* {̉ʓ]֗܂B */
	old_LCDTransDirect(lcd);
}

/* |[Y܂START+SELECTŏIƁApceLCDTransDirect()̃tbN܂B
 * ̖h߁AIʒmnhOAmpceLCDTransDirect()̃tbNs܂B
 */
int
pceAppNotify(int type, int param)
{
extern unsigned char _def_vbuff[];

	switch(type) {
	/*{{C:\usr\PIECE\lib\src\defnotify.c*/
	case APPNF_SMSTART:
		return APPNR_ACCEPT;
	case APPNF_SMREQVBUF:
		pceLCDSetBuffer(_def_vbuff);
		return APPNR_ACCEPT;
	/*}}C:\usr\PIECE\lib\src\defnotify.c*/
	case APPNF_EXITREQ:
		pausedisp(0); /* mpceLCDTransDirect()̃tbN */
		return APPNR_ACCEPT;
	}
	return APPNR_IGNORE;
}

void
pausedisp(int pause)
{
	thread_lock();
	if(pause) {
		if(old_LCDTransDirect == NULL) {
			old_LCDTransDirect = pceVectorSetKs(KSNO_LCDTransDirect, new_LCDTransDirect);
		}
	} else {
		if(old_LCDTransDirect != NULL) {
			pceVectorSetKs(KSNO_LCDTransDirect, old_LCDTransDirect);
			old_LCDTransDirect = NULL; /* tbNĂȂƂ}[N */
		}
	}
	thread_unlock();
}

